# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_with repolib

%if 0
%define reltag _redhat_1
%define namedreltag -redhat-1
%endif
%global namedversion %{version}%{?namedversion}

%define section free

Name:           jna
Version:        3.2.7
Release:        13.2%{?reltag}%{?dist}
Epoch:          0
Summary:        Java Native Access
License:        LGPLv2+
Group:          Development/Libraries/Java
URL:            https://jna.dev.java.net/
# svn -q export https://svn.java.net/svn/jna~svn/tags/3.2.7 jna-3.2.7 --username guest --password "" && tar cjf jna-3.2.7.tar.bz2 jna-3.2.7
Source0:        jna-3.2.7.tar.bz2
Patch0:         jna-build.patch
Patch1:         jna-pom.patch
Patch2:         jna-pom-versions.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  ant
BuildRequires:  ant-junit
BuildRequires:  ant-nodeps
BuildRequires:  ant-trax
BuildRequires:  java-devel
BuildRequires:  jpackage-utils
BuildRequires:  junit
#
BuildRequires:  maven2
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-wagon
#
BuildRequires:  gcc
BuildRequires:  %{_includedir}/X11/Intrinsic.h
BuildRequires:  maven-antrun-extended-plugin
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
JNA provides Java programs easy access to native shared
libraries (DLLs on Windows) without writing anything but
Java code. No JNI or native code is required. This functionality
is comparable to Windows' Platform/Invoke and Python's ctypes.
Access is dynamic at runtime without code generation.
JNA's design aims to provide native access in a natural way
with a minimum of effort. No boilerplate or generated code is
required. While some attention is paid to performance,
correctness and ease of use take priority.

The JNA library uses a small native library stub to dynamically
invoke native code. The developer uses a Java interface to
describe functions and structures in the target native library.
This makes it quite easy to take advantage of native platform
features without incurring the high overhead of configuring and
building JNI code for multiple platforms.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%if 0
%patch2 -p1 -b .sav2
%endif

# FIXME: this test is crashing the JDK
%{__rm} test/com/sun/jna/DirectTest.java
%{_bindir}/find -type f -name '*.jar' | %{_bindir}/xargs -t %{__rm}

pushd lib
%{__ln_s} `%{_bindir}/build-classpath junit` junit.jar
# XXX: eh
%{__ln_s} `%{_bindir}/build-classpath junit` clover.jar
popd

%build
export CLASSPATH=`pwd`/build-d64/jna.jar:`pwd`/build/jna.jar
export OPT_JAR_LIST="`%{__cat} %{_sysconfdir}/ant.d/{junit,nodeps,trax}`"
%{ant} -Dbuild.sysclasspath=first dist

export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p maven2-brew/net/java/dev/jna/jna/%{namedversion}/jna-%{namedversion}-sources.jar %{buildroot}%{_javadir}/jna-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/net/java/dev/jna/jna/%{namedversion}/jna-%{namedversion}.jar %{buildroot}%{_javadir}/jna-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/net/java/dev/jna/jna/%{namedversion}/jna-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-jna.pom

# depmaps
%add_to_maven_depmap net.java.dev.jna jna %{namedversion} JPP jna

%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr doc/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt release-notes.html
%{_javadir}*/jna-%{namedversion}-sources.jar
%{_javadir}*/jna-sources.jar
%{_javadir}*/jna-%{namedversion}.jar
%{_javadir}*/jna.jar
%{_mavenpomdir}/JPP-jna.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Dec 09 2011 David Walluck <dwalluck@redhat.com> 0:3.2.7-13.2
- disable repolib (fails import for arch packages)

* Fri Dec 09 2011 David Walluck <dwalluck@redhat.com> 0:3.2.7-13.1
- fix BuildRequires

* Mon Dec 05 2011 David Walluck <dwalluck@redhat.com> 0:3.2.7-13
- add pom versions patch (for redhat)

* Mon Dec 05 2011 David Walluck <dwalluck@redhat.com> 0:3.2.7-12
- add repolib

* Wed Nov 16 2011 David Walluck <dwalluck@redhat.com> 0:3.2.7-11
- bump Release to workaround broken el6 version

* Thu Nov 09 2011 David Walluck <dwalluck@redhat.com> 0:3.2.7-1
- 3.2.7

* Sat Jan 09 2010 Will Tatam <will.tatam@red61.com> 3.1.0-2
- Auto rebuild for JPackage 6 in centos5 mock

* Tue Jul 14 2009 David Walluck <dwalluck@redhat.com> 0:3.1.0-1
- 3.1.0

* Mon Jun 30 2008 Ralph Apel <r.apel at r-apel.de> - 0:3.0.3-4.jpp5
- Prefix jar target with compile target

* Mon Jun 30 2008 Ralph Apel <r.apel at r-apel.de> - 0:3.0.3-3.jpp5
- Omit fix for soname in -native

* Mon Jun 30 2008 Ralph Apel <r.apel at r-apel.de> - 0:3.0.3-2.jpp5
- Factor out native build and native package

* Fri May 30 2008 Ralph Apel <r.apel at r-apel.de> - 0:3.0.3-1jpp
- First release
